#ifndef __DOUBLE_VECTOR_H__
#define __DOUBLE_VECTOR_H__


#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

//typedef char bool;
//static const bool false = 0;
//static const bool true  = 1;

/* basic operations */
void double_vector_copy(double * dst, double * src, size_t size);
double * double_vector_neg(double *ov, size_t size);
void double_vector_combine(double* ov1, double * ov2,
		    double* ov3, size_t k, size_t size, int add);

int double_vector_compare_coeff(double* ov1, double* ov2, size_t size);

int double_vector_compare(double* ov1, double* ov2, size_t size);

int double_vector_is_null_expr(double* ov, size_t size);

double * double_vector_scalar_product(double * ov, double s, size_t size);

void double_vector_sum(double * ov1, double *ov2, size_t size);

#ifdef __cplusplus
}
#endif

#endif
